// Mixins
// TODO: Could we use this as a global mixin for other forms also?
// Graphical Radio Buttons
@mixin webform-option-checkmark() {
  &::after {
    content: var(--icon-theme-check);
    font-family: var(--basics-frontend-iconfont-family);
    position: absolute;
    left: 0;
    top: 0;
    width: var(--icon-size-md);
    height: var(--icon-size-md);
    font-size: calc(var(--icon-size-md) - 6px);
    display: flex;
    align-items: center;
    justify-content: center;
    background: var(--bs-focus-ring-color);
    border-bottom-right-radius: var(--bs-border-radius-sm);
    color: var(--bs-white);
    overflow: hidden;
  }
}

.webform-submission-form {
  .form-item {
    >label {
      margin-bottom: 0.15em;
    }
  }

  // make radio items clickable - even the field description
  .js-form-type-radio {
    position: relative;
    padding: var(--bs-spacer-1) var(--bs-spacer-2);

    label {
      margin: 0;

      &::before {
        content: ' ';
        position: absolute;
        top: 0;
        left: 0;
        height: 100%;
        width: 100%;
        z-index: 1;
        border: 1px solid var(--bs-gray-light);
      }
    }

    input {
      display: none;

      &:checked {
        +label {
          color: var(--bs-primary);
          font-weight: var(--bs-font-weight-bold);

          &::before {
            border-color: var(--bs-primary);
          }
        }
      }

      &:active {
        +label {
          &::before {
            border-color: var(--bs-primary);
          }
        }
      }
    }
  }
}

// Styling for webform specific compontents
// Webform options: Display Buttons
.webform-options-display-buttons {
  >.form-item {
    position: relative;

    >label.option {
      // TODO instaed static colors set --bs-input-background & -border as css vars?
      background: var(--bs-white) !important;
      border: var(--bs-gray-light) !important;
      user-select: none;
      font-weight: var(--bs-font-weight-bold);
    }
  }

  >.form-item>input {
    &:focus+label.option {
      box-shadow: none !important;
    }

    &:hover+label.option,
    &:checked+label.option,
    &:checked:focus+label.option {
      // TODO instaed static colors set --bs-input-background-focus & -border-focus as css vars?
      background: var(--bs-white) !important;
      border: var(--bs-primary) !important;
    }

    &:checked+label.option {
      @include webform-option-checkmark;
    }

    &:checked:focus+label.option {
      box-shadow: var(--bs-box-shadow-sm) !important;
    }
  }
}

// Styling for webform specific compontents
// Webform doesnt provide BEM classes, nor reliable markup, so we need this bit hacky solution
// (2 column is default)
[class*='webform-options-display'][class*='-columns'] {
  display: flex;
  flex-flow: row wrap;
  max-width: none;
  column-count: none;
  margin: -8px;

  >* {
    flex: 1 0 calc(50% - 16px);
    margin: 8px !important;
  }

  label.option {
    font-weight: var(--bs-font-weight-bold);
  }

  input:checked+label.option {
    @include webform-option-checkmark;
    padding-left: 10px;

    ~* {
      padding-left: 10px;
    }
  }
}

.webform-options-display-three-columns {
  >* {
    flex-basis: calc(33.333% - 16px) !important;
  }
}

// Ensure webforms form-no-label class is working:
// This affects inline form elements, for example
// date-time fields. They have one label for the compbined
// date+time field and furthermore one label for each field
// (date + time). The last ones should be hidden by
// .form-no-label, but there is no according CSS code.
.form-no-label {
  >label {
    display: none !important;
  }
}

// Webform sets display: table to this, probably part of an old
// clearfix, we dont want this.
.webform-options-display-buttons .form-item {
  display: block;
}
